#ifndef __CUSTOMGUI_LISTVIEW2_H__
#define __CUSTOMGUI_LISTVIEW2_H__

//////////////////////////////////////////////////////////////////////////

//#include "c4d_customguidata.h"
//#include "c4d_string.h"
//#include "c4d_memory.h"
//#include "c4d_gui.h"
//#include "c4d_basecontainer.h"
//#include "c4d_baselist.h"
//#include "c4d_basebitmap.h"
//#include "c4d_baseselect.h"
//#include "c4d_basematerial.h"
//#include "c4d_basedocument.h"
//#include "c4d_baseobject.h"
#include "lib_description.h"
//#include "c4d_general.h"
//#include "c4d_resource.h"
//#include "c4d_colors.h"
#include "customgui_base.h"

//////////////////////////////////////////////////////////////////////////

#define CUSTOMDATA_LISTVIEW	1018397
#define CUSTOMGUI_LISTVIEW 1018398

class iListViewData;

class ListViewData : public CustomDataType
{
private:
	ListViewData();
	~ListViewData();
public:
	static ListViewData* Alloc();
	static void Free(ListViewData *&pData);

	Bool AddItem(LONG id, const String &name, const GeData &data);
	Bool UpdateItem(LONG id, const String &name, const GeData &data);
	void RemoveItem(LONG id);

	LONG GetCount();
	LONG GetSelected();
	void Select(LONG index);

	GeData GetData(LONG index);
	String GetName(LONG index);
	LONG GetID(LONG index);

	void SetData(LONG index, const GeData &data);
	void SetName(LONG index, const String &name);
	void SetID(LONG index, LONG id);

	LONG FindIndex(LONG id);
};

//////////////////////////////////////////////////////////////////////////

struct CustomGuiListViewLib : public BaseCustomGuiLib
{
	iListViewData *(*Alloc)();
	void (*Free)(iListViewData *&pData);

	Bool (iListViewData::*AddItem)(LONG id, const String &name, const GeData &data);
	Bool (iListViewData::*UpdateItem)(LONG id, const String &name, const GeData &data);
	void (iListViewData::*RemoveItem)(LONG id);
	LONG (iListViewData::*GetCount)();
	LONG (iListViewData::*GetSelected)();
	void (iListViewData::*Select)(LONG index);
	GeData (iListViewData::*GetData)(LONG index);
	String (iListViewData::*GetName)(LONG index);
	LONG (iListViewData::*GetID)(LONG index);
	void (iListViewData::*SetData)(LONG index, const GeData &data);
	void (iListViewData::*SetName)(LONG index, const String &name);
	void (iListViewData::*SetID)(LONG index, LONG id);
	LONG (iListViewData::*FindIndex)(LONG id);
};

//////////////////////////////////////////////////////////////////////////

#endif // __CUSTOMGUI_LISTVIEW_H__