#include "lib_ca.h"

//////////////////////////////////////////////////////////////////////////

CALibrary *lib_ca = NULL;

static CALibrary *CheckCALib(LONG offset)
{
	return (CALibrary*)CheckLib(LIBRARY_CA,offset,(C4DLibrary**)&lib_ca);
}

#define CALibCall(b) 		CALibrary *lib = CheckCALib(LIBOFFSET(CALibrary, b)); \
															if (!lib || !lib->b) return; \
															(lib->b)

#define CALibCallR(a,b)  CALibrary *lib = CheckCALib(LIBOFFSET(CALibrary, b)); \
															if (!lib || !lib->b) return a; \
															return (lib->b)

//////////////////////////////////////////////////////////////////////////

BaseObject *CAWeightTag::GetJoint(LONG index, BaseDocument *doc) { CALibCallR(NULL,weightGetJoint)(this,index,doc); }
LONG CAWeightTag::GetJointCount() { CALibCallR(0,weightGetJointCount)(this); }
LONG CAWeightTag::FindJoint(BaseObject *op, BaseDocument *doc) { CALibCallR(NOTOK,weightFindJoint)(this,op,doc); }
JointRestState CAWeightTag::GetJointRestState(LONG index) { CALibCallR(JointRestState(),weightGetJointRestState)(this,index); }
void CAWeightTag::SetJointRestState(LONG index, const JointRestState &state) { CALibCall(weightSetJointRestState)(this,index,state); }
void CAWeightTag::GetWeightMap(LONG index, SReal *map, LONG cnt) { CALibCall(weightGetWeightMap)(this,index,map,cnt); }
Bool CAWeightTag::SetWeightMap(LONG index, SReal *map, LONG cnt) { CALibCallR(FALSE,weightSetWeightMap)(this,index,map,cnt); }
LONG CAWeightTag::GetWeightCount(LONG index) { CALibCallR(0,weightGetWeightCount)(this,index); }
void CAWeightTag::GetIndexWeight(LONG index, LONG windex, LONG &pntindex, Real &weight) { CALibCall(weightGetIndexWeight)(this,index,windex,pntindex,weight); }
Real CAWeightTag::GetWeight(LONG index, LONG pntindex) { CALibCallR(0.0,weightGetWeight)(this,index,pntindex); }
Bool CAWeightTag::SetWeight(LONG index, LONG pntindex, Real weight) { CALibCallR(FALSE,weightSetWeight)(this,index,pntindex,weight); }
ULONG CAWeightTag::GetWeightDirty() { CALibCallR(0,weightGetDirty)(this); }
void CAWeightTag::WeightDirty() { CALibCall(weightDirty)(this); }
Matrix CAWeightTag::GetGeomMg() { CALibCallR(Matrix(),weightGetGeomMg)(this); }
void CAWeightTag::SetGeomMg(const Matrix &mg) { CALibCall(weightSetGeomMg)(this,mg); }
LONG CAWeightTag::AddJoint(BaseObject *op) { CALibCallR(NOTOK,weightAddJoint)(this,op); }
void CAWeightTag::RemoveJoint(BaseObject *op) { CALibCall(weightRemoveJoint)(this,op); }
void CAWeightTag::CalculateBoneStates(LONG index) { CALibCall(weightCalculateBoneStates)(this,index); }
Bool CAWeightTag::TransferWeightMap(BaseDocument *doc, CAWeightTag *dst, LONG sindex, LONG dindex, LONG offset, LONG cnt, AliasTrans *trans) { CALibCallR(FALSE,weightTransferWeightMap)(this,doc,dst,sindex,dindex,offset,cnt,trans); }

//////////////////////////////////////////////////////////////////////////

LONG CAPoseMorphTag::GetMorphCount() { CALibCallR(0,pmorphGetCount)(this); }
CAMorph *CAPoseMorphTag::GetMorph(LONG index) { CALibCallR(NULL,pmorphGetMorph)(this,index); }
DescID CAPoseMorphTag::GetMorphID(LONG index) { CALibCallR(DescID(),pmorphGetDescID)(this,index); }
LONG CAPoseMorphTag::GetActiveMorphIndex() { CALibCallR(NOTOK,pmorphGetActive)(this); }
LONG CAPoseMorphTag::GetMode() { CALibCallR(NOTOK,pmorphGetMode)(this); }
CAMorph *CAPoseMorphTag::AddMorph() { CALibCallR(NULL,pmorphAdd)(this); }
void CAPoseMorphTag::RemoveMorph(LONG index) { CALibCall(pmorphRemove)(this,index); }
void CAPoseMorphTag::InitMorphs() { CALibCall(pmorphInitMorphs)(this); }
void CAPoseMorphTag::UpdateMorphs() { CALibCall(pmorphUpdateMorphs)(this); }
LONG CAPoseMorphTag::GetMorphIndex(CAMorph *morph) { CALibCallR(NOTOK,pmorphGetMorphIndex)(this,morph); }
Bool CAPoseMorphTag::ExitEdit(BaseDocument *doc, Bool apply) { CALibCallR(FALSE,pmorphExitEdit)(this,doc,apply); }

String CAMorph::GetName() { CALibCallR(String(),pmorphGetName)(this); }
LONG CAMorph::GetID() { CALibCallR(NOTOK,pmorphGetID)(this); }
void CAMorph::SetName(const String &name) { CALibCall(pmorphSetName)(this,name); }
Bool CAMorph::CopyFrom(CAMorph *src, AliasTrans *trn, CAMORPH_COPY_FLAGS flags) { CALibCallR(FALSE,pmorphCopyFrom)(this,src,trn,flags); }
CAMorphNode *CAMorph::Find(CAPoseMorphTag *tag, BaseList2D *bl) { CALibCallR(NULL,pmorphFind)(this,tag,bl); }
CAMorphNode *CAMorph::GetFirst() { CALibCallR(NULL,pmorphGetFirst)(this); }
Bool CAMorph::SetMode(BaseDocument *doc, CAPoseMorphTag *tag, CAMORPH_MODE_FLAGS flags, CAMORPH_MODE mode) { CALibCallR(FALSE,pmorphSetMode)(this,doc,tag,flags,mode); }
LONG CAMorph::FindIndex(CAPoseMorphTag *tag, BaseList2D *bl) { CALibCallR(NOTOK,pmorphFindIndex)(this,tag,bl); }
CAMorphNode *CAMorph::FindFromIndex(CAPoseMorphTag *tag, LONG index) { CALibCallR(NULL,pmorphFindFromIndex)(this,tag,index); }
Bool CAMorph::Store(BaseDocument *doc, CAPoseMorphTag *tag, CAMORPH_DATA_FLAGS flags) { CALibCallR(FALSE,pmorphStore)(this,doc,tag,flags); }
Bool CAMorph::Apply(BaseDocument *doc, CAPoseMorphTag *tag, CAMORPH_DATA_FLAGS flags) { CALibCallR(FALSE,pmorphApply)(this,doc,tag,flags); }
LONG CAMorph::GetNodeIndex(CAMorphNode *node) { CALibCallR(NOTOK,pmorphGetNodeIndex)(this,node); }

CAMorphNode *CAMorphNode::GetNext() { CALibCallR(NULL,pmorphnodeGetNext)(this); }
CAMorphNode *CAMorphNode::GetPrev() { CALibCallR(NULL,pmorphnodeGetPrev)(this); }
CAMorphNode *CAMorphNode::GetUp() { CALibCallR(NULL,pmorphnodeGetUp)(this); }
CAMorphNode *CAMorphNode::GetDown() { CALibCallR(NULL,pmorphnodeGetDown)(this); }
BaseList2D *CAMorphNode::GetLink(CAPoseMorphTag *tag, CAMorph *morph, BaseDocument *doc) { CALibCallR(NULL,pmorphnodeGetLink)(this,tag,morph,doc); }
LONG CAMorphNode::GetPointCount() { CALibCallR(0,pmorphnodeGetPointCount)(this); }
Vector CAMorphNode::GetPoint(LONG index) { CALibCallR(Vector(),pmorphnodeGetPoint)(this,index); }
void CAMorphNode::SetPoint(LONG index, const Vector &pnt) { CALibCall(pmorphnodeSetPoint)(this,index,pnt); }
LONG CAMorphNode::GetTangentCount() { CALibCallR(0,pmorphGetTangentCount)(this); }
Vector CAMorphNode::GetTangent(LONG index) { CALibCallR(Vector(),pmorphGetTangent)(this,index); }
void CAMorphNode::SetTangent(LONG index, const Vector &v) { CALibCall(pmorphSetTangent)(this,index,v); }
LONG CAMorphNode::GetVertexMapTagCount() { CALibCallR(0,pmorphGetVertexMapTagCount)(this); }
LONG CAMorphNode::GetVertexMapCount(LONG tindex) { CALibCallR(0,pmorphGetVertexMapCount)(this,tindex); }
Real CAMorphNode::GetVertexMap(LONG tindex, LONG index) { CALibCallR(0.0,pmorphGetVertexMap)(this,tindex,index); }
void CAMorphNode::SetVertexMap(LONG tindex, LONG index, Real v) { CALibCall(pmorphSetVertexMap)(this,tindex,index,v); }
Bool CAMorphNode::SetVertexMapCount(LONG tindex, LONG cnt) { CALibCallR(FALSE,pmorphSetVertexMapCount)(this,tindex,cnt); }
Bool CAMorphNode::SetPointCount(LONG cnt) { CALibCallR(FALSE,pmorphSetPointCount)(this,cnt); }
Bool CAMorphNode::SetTangentCount(LONG cnt) { CALibCallR(FALSE,pmorphSetTangentCount)(this,cnt); }
CAMORPH_DATA_FLAGS CAMorphNode::GetInfo() { CALibCallR(CAMORPH_DATA_FLAGS_0,pmorphGetInfo)(this); }
Vector CAMorphNode::GetP() { CALibCallR(FALSE,pmorphGetP)(this); }
Vector CAMorphNode::GetS() { CALibCallR(FALSE,pmorphGetS)(this); }
Vector CAMorphNode::GetR() { CALibCallR(FALSE,pmorphGetR)(this); }
void CAMorphNode::SetP(const Vector &p) { CALibCall(pmorphSetP)(this,p); }
void CAMorphNode::SetS(const Vector &s) { CALibCall(pmorphSetS)(this,s); }
void CAMorphNode::SetR(const Vector &r) { CALibCall(pmorphSetR)(this,r); }
LONG CAMorphNode::GetParamCount() { CALibCallR(FALSE,pmorphGetParamCount)(this); }
Bool CAMorphNode::SetParamCount(LONG cnt) { CALibCallR(FALSE,pmorphSetParamCount)(this,cnt); }
Bool CAMorphNode::GetParam(LONG index, GeData &data, DescID &id) { CALibCallR(FALSE,pmorphGetParam)(this,index,data,id); }
void CAMorphNode::SetParam(LONG index, const GeData &data, const DescID &id) { CALibCall(pmorphSetParam)(this,index,data,id); }
LONG CAMorphNode::GetUVTagCount() { CALibCallR(FALSE,pmorphGetUVTagCount)(this); }
LONG CAMorphNode::GetUVCount(LONG tindex) { CALibCallR(FALSE,pmorphGetUVCount)(this,tindex); }
Bool CAMorphNode::SetUVCount(LONG tindex, LONG cnt) { CALibCallR(FALSE,pmorphSetUVCount)(this,tindex,cnt); }
void CAMorphNode::GetUV(LONG tindex, LONG index, UVWStruct &uv) { CALibCall(pmorphGetUV)(this,tindex,index,uv); }
void CAMorphNode::SetUV(LONG tindex, LONG index, const UVWStruct &uv) { CALibCall(pmorphSetUV)(this,tindex,index,uv); }
LONG CAMorphNode::GetWeightMapTagCount() { CALibCallR(FALSE,pmorphGetWeightMapTagCount)(this); }
LONG CAMorphNode::GetWeightMapJointCount(LONG tindex) { CALibCallR(FALSE,pmorphGetWeightMapJointCount)(this,tindex); }
LONG CAMorphNode::GetWeightMapCount(LONG tindex, LONG jindex) { CALibCallR(FALSE,pmorphGetWeightMapCount)(this,tindex,jindex); }
Bool CAMorphNode::SetWeightMapCount(LONG tindex, LONG jindex, LONG cnt) { CALibCallR(FALSE,pmorphSetWeightMapCount)(this,tindex,jindex,cnt); }
Real CAMorphNode::GetWeightMap(LONG tindex, LONG jindex, LONG index) { CALibCallR(FALSE,pmorphGetWeightMap)(this,tindex,jindex,index); }
void CAMorphNode::SetWeightMap(LONG tindex, LONG jindex, LONG index, Real v) { CALibCall(pmorphSetWeightMap)(this,tindex,jindex,index,v); }

//////////////////////////////////////////////////////////////////////////

void CAJointObject::GetBone(Matrix &m, Real &len) { CALibCall(jointGetBone)(this,m,len); }
CAWeightTag *CAJointObject::GetWeightTag(LONG &index) { CALibCallR(NULL,jointGetWeightTag)(this,index); }

//////////////////////////////////////////////////////////////////////////

void RemoveXRefData(BaseDocument *doc, BaseList2D *bl)
{
	CALibCall(xrefStripRefData)(doc,bl);
}

Bool HasDocumentXRefs(BaseDocument *doc)
{
	CALibCallR(FALSE,xrefHasRefs)(doc);
}

LONG GetDocumentXRefState()
{
	CALibCallR(0,xrefGetState)();
}

LULONG GetXRefID(BaseList2D *bl)
{
	CALibCallR(0,xrefGetID)(bl);
}

Bool XRefHasParam(BaseDocument *doc, BaseList2D *bl, const DescID &id)
{
	CALibCallR(FALSE,xrefHasParam)(doc,bl,id);
}

Bool XRefGetParam(BaseDocument *doc, BaseList2D *bl, const DescID &id, GeData &dat)
{
	CALibCallR(0,xrefGetParam)(doc,bl,id,dat);
}

Bool XRefRemoveParam(BaseDocument *doc, BaseList2D *bl, const DescID &id)
{
	CALibCallR(FALSE,xrefRemoveParam)(doc,bl,id);
}

//////////////////////////////////////////////////////////////////////////

BrushBaseLibrary *lib_brushbase = NULL;

static BrushBaseLibrary *CheckBrushBaseLibrary(LONG offset)
{
	return (BrushBaseLibrary*)CheckLib(LIBRARY_BRUSH,offset,(C4DLibrary**)&lib_brushbase);
}

#define BrushBaseLibraryCall(b) 		BrushBaseLibrary *lib = CheckBrushBaseLibrary(LIBOFFSET(BrushBaseLibrary, b)); \
															if (!lib || !lib->b) return; \
															(((iBrushBase*)this)->*lib->b)

#define BrushBaseLibraryCallR(a,b)  BrushBaseLibrary *lib = CheckBrushBaseLibrary(LIBOFFSET(BrushBaseLibrary, b)); \
															if (!lib || !lib->b) return a; \
															return (((iBrushBase*)this)->*lib->b)

BrushBase* BrushBase::Alloc()
{
	BrushBaseLibrary *lib = CheckBrushBaseLibrary(LIBOFFSET(BrushBaseLibrary,Alloc)); if (!lib) return NULL;
	return (BrushBase*)lib->Alloc();
}

void BrushBase::Free(BrushBase *&p)
{
	if (!p) return;
	BrushBaseLibrary *lib = CheckBrushBaseLibrary(LIBOFFSET(BrushBaseLibrary,Free)); if (!lib) return;
	iBrushBase* i = (iBrushBase*)p;
	lib->Free(i);
	p = NULL;
}

Bool BrushBase::InitTool(BaseDocument* doc, BaseContainer& data, BaseThread* bt, BrushToolData *tool) { BrushBaseLibraryCallR(FALSE,InitTool)(doc,data,bt,tool); }
void BrushBase::FreeTool(BaseDocument* doc, BaseContainer& data) { BrushBaseLibraryCall(FreeTool)(doc,data); }
void BrushBase::InitDefaultSettings(BaseDocument *doc, BaseContainer &data) { BrushBaseLibraryCall(InitDefaultSettings)(doc,data); }
Bool BrushBase::GetDEnabling(BaseDocument* doc, BaseContainer& data, const DescID& id, const GeData& t_data, DESCFLAGS_ENABLE flags, const BaseContainer* itemdesc) { BrushBaseLibraryCallR(FALSE,GetDEnabling)(doc,data,id,t_data,flags,itemdesc); }
Bool BrushBase::SetDParameter(BaseDocument* doc, BaseContainer& data, const DescID& id, const GeData& t_data, DESCFLAGS_SET& flags) { BrushBaseLibraryCallR(FALSE,SetDParameter)(doc,data,id,t_data,flags); }
Bool BrushBase::GetDDescription(BaseDocument* doc, BaseContainer& data, Description* description, DESCFLAGS_DESC& flags) { BrushBaseLibraryCallR(FALSE,GetDDescription)(doc,data,description,flags); }
Bool BrushBase::Message(BaseDocument *doc, BaseContainer &data, LONG type, void *t_data) { BrushBaseLibraryCallR(FALSE,Message)(doc,data,type,t_data); }
Bool BrushBase::GetCursorInfo(BaseDocument* doc, BaseContainer& data, BaseDraw* bd, Real x, Real y, BaseContainer& bc) { BrushBaseLibraryCallR(FALSE,GetCursorInfo)(doc,data,bd,x,y,bc); }
Bool BrushBase::MouseInput(BaseDocument* doc, BaseContainer& data, BaseDraw* bd, EditorWindow* win, const BaseContainer& msg) { BrushBaseLibraryCallR(FALSE,MouseInput)(doc,data,bd,win,msg); }
BrushVertexData *BrushBase::GetSelected(BaseDocument* doc, BaseContainer& data, BaseDraw* bd, LONG &vcnt, LONG x, LONG y, Real rad, BaseObject *op) { BrushBaseLibraryCallR(NULL,GetSelected)(doc,data,bd,vcnt,x,y,rad,op); }
Real BrushBase::GetCursor(LONG &x, LONG &y) { BrushBaseLibraryCallR(0.0,GetCursor)(x,y); }
void BrushBase::GetObjectInfo(BrushObjectData *data, BrushObjectInfo &info) { BrushBaseLibraryCall(GetObjectInfo)(data,info); }
Bool BrushBase::GetObjectInfo(BaseObject *op, BrushObjectInfo &info) { BrushBaseLibraryCallR(FALSE,GetObjectInfoOp)(op,info); }
BrushPixelData *BrushBase::GetObjectAt(LONG x, LONG y) { BrushBaseLibraryCallR(NULL,GetObjectAt)(x,y); }
Bool BrushBase::ValidateObjects(BaseDocument *doc, BaseContainer& data) { BrushBaseLibraryCallR(FALSE,ValidateObjects)(doc,data); }
Real BrushBase::GetFalloff(Real dst, LONG flags) { BrushBaseLibraryCallR(0.0,GetFalloff)(dst,flags); }
Bool BrushBase::GetObjects(BaseDocument *doc, AtomArray *objects) { BrushBaseLibraryCallR(FALSE,GetObjects)(doc,objects); }
Bool BrushBase::UpdateCache(BaseDocument *doc, BaseContainer& data, BaseDraw *bd, Bool force) { BrushBaseLibraryCallR(FALSE,UpdateCache)(doc,data,bd,force); }
Real *BrushBase::CalcSurfaceDistances(PolygonObject *pObject, BaseSelect *selected, Neighbor *pNeighbor, Vector *pNormals, Vector *pGlobalPoints, Real *pDistance) { BrushBaseLibraryCallR(NULL,CalcSurfaceDistances)(pObject,selected,pNeighbor,pNormals,pGlobalPoints,pDistance); }
Real *BrushBase::CalcSurfaceDistancesFromPoint(PolygonObject *pObject, LONG pindex, Neighbor *pNeighbor, Vector *pNormals, Vector *pGlobalPoints, Real *pDistance) { BrushBaseLibraryCallR(NULL,CalcSurfaceDistancesFromPoint)(pObject,pindex,pNeighbor,pNormals,pGlobalPoints,pDistance); }

//////////////////////////////////////////////////////////////////////////

#ifndef __API_INTERN__

Bool BrushToolData::InitTool(BaseDocument* doc, BaseContainer& data, BaseThread* bt)
{
	if (!m_pBrushBase) m_pBrushBase=BrushBase::Alloc();
	if (!m_pBrushBase) return FALSE;
	return m_pBrushBase->InitTool(doc,data,bt,this);
}
void BrushToolData::FreeTool(BaseDocument* doc, BaseContainer& data)
{
	if (m_pBrushBase) m_pBrushBase->FreeTool(doc,data);
	BrushBase::Free(m_pBrushBase);
}

void BrushToolData::InitDefaultSettings(BaseDocument *doc, BaseContainer &data)
{
	if (!m_pBrushBase) m_pBrushBase=BrushBase::Alloc();
	if (m_pBrushBase) m_pBrushBase->InitDefaultSettings(doc,data);
}
Bool BrushToolData::GetDEnabling(BaseDocument* doc, BaseContainer& data, const DescID& id, const GeData& t_data, DESCFLAGS_ENABLE flags, const BaseContainer* itemdesc) { return (m_pBrushBase)?m_pBrushBase->GetDEnabling(doc,data,id,t_data,flags,itemdesc):FALSE; }
Bool BrushToolData::SetDParameter(BaseDocument* doc, BaseContainer& data, const DescID& id, const GeData& t_data, DESCFLAGS_SET& flags) { return (m_pBrushBase)?m_pBrushBase->SetDParameter(doc,data,id,t_data,flags):FALSE; }
Bool BrushToolData::GetDDescription(BaseDocument* doc, BaseContainer& data, Description* description, DESCFLAGS_DESC& flags)
{
	if (!m_pBrushBase) m_pBrushBase=BrushBase::Alloc();	// FIX[12637]
	if (!SUPER::GetDDescription(doc,data,description,flags)) return FALSE;
	return (m_pBrushBase)?m_pBrushBase->GetDDescription(doc,data,description,flags):FALSE;
}
Bool BrushToolData::Message(BaseDocument *doc, BaseContainer &data, LONG type, void *t_data) { return (m_pBrushBase)?m_pBrushBase->Message(doc,data,type,t_data):FALSE; }
Bool BrushToolData::GetCursorInfo(BaseDocument* doc, BaseContainer& data, BaseDraw* bd, Real x, Real y, BaseContainer& bc) { return (m_pBrushBase)?m_pBrushBase->GetCursorInfo(doc,data,bd,x,y,bc):FALSE; }
Bool BrushToolData::MouseInput(BaseDocument* doc, BaseContainer& data, BaseDraw* bd, EditorWindow* win, const BaseContainer& msg) { return (m_pBrushBase)?m_pBrushBase->MouseInput(doc,data,bd,win,msg):FALSE; }

#endif
