#include "operatingsystem.h"
#include "c4d_memory.h"
#include "c4d_general.h"
#include "c4d_shaderplugin.h"
#include "c4d_resource.h"
#ifndef __API_INTERN__
	#include "c4d_tools.h"
#else
	#include "shdlist.h"
#endif

SHADERINFO ShaderData::GetRenderInfo(BaseShader *chn)
{
	return SHADERINFO_0;
}

INITRENDERRESULT ShaderData::InitRender(BaseShader *chn, const InitRenderStruct &irs)
{
	return INITRENDERRESULT_OK;
}

void ShaderData::FreeRender(BaseShader *chn)
{
}

Vector ShaderData::Output(BaseShader *chn, ChannelData *cd)
{
	return 0.0;
}

Bool ShaderData::Draw(BaseShader *chn, BaseObject *op, BaseTag *tag, BaseDraw *bd, BaseDrawHelp *bh)
{
	return TRUE;
}

GL_MESSAGE ShaderData::GlMessage(BaseShader *sh, LONG type, void *msgdata)
{
	return GL_MESSAGE_ERROR;
}

LONG ShaderData::InitGLImage(BaseShader *sh, BaseDocument* doc, BaseThread* th, BaseBitmap *bmp, Bool alpha, LONG doccolorspace, Bool linearworkflow)
{
	return 0;
}

void ShaderData::DestroyGLImage(BaseShader *sh, BaseDocument* doc)
{
}

void ShaderData::InvalidateGLImage(BaseShader *sh, BaseDocument* doc)
{
}

Bool ShaderData::GetGLImageSize(BaseShader *sh, BaseDocument* doc, LONG s, Bool noScale, LONG &w, LONG &h)
{
	return FALSE;
}

void FillShaderPlugin(SHADERPLUGIN *np, DataAllocator *npalloc, LONG info, LONG disklevel, void *emulation)
{
	FillNodePlugin(np,info,npalloc,NULL,disklevel,emulation);

	np->Draw								= &ShaderData::Draw;
	np->GetRenderInfo				= &ShaderData::GetRenderInfo;
	np->InitRender					= &ShaderData::InitRender;
	np->FreeRender					= &ShaderData::FreeRender;
	np->Output							= &ShaderData::Output;
	np->GlMessage						= &ShaderData::GlMessage;
	np->InitGLImage					= &ShaderData::InitGLImage;
	np->GetGLImageSize			= &ShaderData::GetGLImageSize;
	np->DestroyGLImage			= &ShaderData::DestroyGLImage;
	np->InvalidateGLImage		= &ShaderData::InvalidateGLImage;
}

Bool RegisterShaderPlugin(LONG id, const String &str, LONG info, DataAllocator *npalloc, const String &description, LONG disklevel, void *emulation)
{
	if (description.Content() && !RegisterDescription(id,description)) return FALSE;

	SHADERPLUGIN np;
	ClearMem(&np,sizeof(np));
	FillShaderPlugin(&np,npalloc,info,disklevel,emulation);
	return GeRegisterPlugin(PLUGINTYPE_SHADER,id,str,&np,sizeof(np));
}
